package com.zipcodewilmington.singlylinkedlist;

/**
 * Created by leon on 1/10/18.
 */
public class SinglyLinkedList<N> {
    private Node firstNode;
    private Node lastNode;
    private int nodeCount;

    public SinglyLinkedList() {
        firstNode = null;
        lastNode = null;
    }

    public int size() {
        return nodeCount;
    }

    public void add(N item) {

        if (firstNode == null) {
            firstNode = new Node(item);
            System.out.println(firstNode.getNodeItem());
        }

        while (firstNode.getNextNode() != null) {
            Node newLastNode = new Node(item);
            lastNode.setNextNode(newLastNode);
            lastNode = newLastNode;
            System.out.println(newLastNode.nodeItem);

        }

        nodeCount++;

    }

    public void insert(N item, int position) {
        if (size() < position) {
            throw new IllegalStateException("LinkedList is smaller than position.");
        }

        Node currentNode = firstNode;

        for (int i = 1; i < position && currentNode != null; i++) {
            currentNode = currentNode.getNextNode();
        }

        Node newNode = new Node(item);
        Node nextNode = currentNode.getNextNode();
        currentNode.setNextNode(newNode);
        newNode.setNextNode(nextNode);
        nodeCount++;


    }

    public void remove(N item) {
        if (firstNode == null) {
            throw new IllegalStateException("Linked List is empty!");
        }

        N nodeItem = firstNode.getNodeItem();

        firstNode = firstNode.getNextNode();
        nodeCount--;

    }


    public boolean contains(N item) {

        if (firstNode.getNodeItem().equals(item)) {
            return true;
        } else {
            Node currentNode = firstNode;
            for (int i = 1; i < nodeCount; i++) {
                currentNode = currentNode.getNextNode();
                if (currentNode.getNodeItem().equals(item)) {
                    return true;
                }
            }
        }
        return false;
    }

    public Integer find(N item) {
        if (firstNode.getNodeItem().equals(item)) {
            return (Integer) firstNode.nodeItem;
        }

        System.out.println(firstNode.nextNode);

        while (firstNode.nextNode != null) {
            Node currentNode = firstNode;

//            System.out.println(currentNode.nodeItem);

            currentNode = currentNode.getNextNode();
            if (currentNode.getNodeItem().equals(item)) {
                return (Integer) currentNode.nodeItem;
            }
            System.out.println("Current Item: " + currentNode.getNodeItem());
            nodeCount++;
        }


        return -1;
    }

    public Integer get(N num) {
        int count = 0;

        if (firstNode.nextNode == null){
            System.out.println(("There is only 1 number"));
            return count;
        }

        count = 1;
        while (firstNode.nextNode != null){
            System.out.println(("There is more than 1 number"));

            Node currentNode = firstNode.nextNode;
            if (currentNode.getNodeItem() == num){
                return count;
            }
            count++;

        }
        return null;
    }


    private class Node {
        private Node nextNode;
        private N nodeItem;

        private Node(N item) {
            this.nextNode = nextNode;
            this.nodeItem = item;
        }


        public Node getNextNode() {
            return nextNode;
        }

        public void setNextNode(Node nextNode) {
            this.nextNode = nextNode;
        }

        public N getNodeItem() {
            return nodeItem;
        }

    }

}
